﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace CSharpSample
{
    public partial class ExtractForm : Form
    {
        public ExtractForm()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            openFileDialog1.InitialDirectory = Path.GetDirectoryName(Application.ExecutablePath);
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                txtSource.Text = openFileDialog1.FileName;
            }

        }

        private void button2_Click(object sender, EventArgs e)
        {
            saveFileDialog1.FileName = openFileDialog1.SafeFileName;
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                txtDestination.Text = saveFileDialog1.FileName;
            }
        }

        private void btnOk_Click(object sender, EventArgs e)
        {
            bool boolSource, boolDest;
            boolSource = sourceValidation();
            boolDest = destinationValidation();
            if (boolDest && boolSource)
                this.DialogResult = DialogResult.OK;

        }

        private void txtSource_TextChanged(object sender, EventArgs e)
        {
            errorProvider1.Clear();
        }

        private void txtDestination_TextChanged(object sender, EventArgs e)
        {
            errorProvider2.Clear();
        }

        private bool sourceValidation()
        {
            if (txtSource.Text.Trim() == string.Empty)
            {
                errorProvider1.SetError(txtSource, "Please select source file");
                return false;
            }
            return true;
        }

        private bool destinationValidation()
        {
            if (txtDestination.Text.Trim() == string.Empty)
            {
                errorProvider2.SetError(txtDestination, "Please select destination file");
                return false;
            }
            return true;
        }
    }
}
